/* ----------------------------------------------------------
	C H A N G E    L O G
	April-17-2015
		Looked at the file format
		header is a container, there are 2 sub blocks
		one is model, the other is texture
		
		the model block has sub blocks
		the model sub block header
		IS NOT COMPLETED
		
		but reading the model block component table
		addresses, and sub blocks
		
		Basic geomety Imported
	- mariokart64n

*/ ----------------------------------------------------------
global f



filen = GetOpenFileName \
caption:"Select GRID File" \
types: "Wangan Midnight (*.GRID)|*.GRID|All files (*.*)|*.*|"

struct _geometry (
	position=#(),
	uv_coordinate=#(),
	matid=#(),
	matcount=#(),
	face=#()
	)

struct _header (
	fileid = "",
	filever = 0,
	unk1 = "",
	unk2 = 0,
	count = 0,
	offsets=#(),
	sizes=#()
	)

struct _subheader (
	type=0,
	unk1=0,
	size=0,
	unk2=0,
	unk3=0
	)

struct _filetable (
	unk1=0,
	unk2=0,
	unk3=0,
	offsets = #()
	)

fn readBEfloat fstream = (
	bit.intAsFloat (bit.swapBytes (bit.swapBytes (readlong fstream #unsigned) 1 4) 2 3)
	)

fn readBElong fstream = (
	bit.swapBytes (bit.swapBytes (readlong fstream #unsigned) 1 4) 2 3
	)

fn readBEshort fstream = (
	bit.swapBytes (readshort fstream #unsigned) 1 2
	)
	
fn getpadding num alignment = (
	mod (alignment-(mod num alignment)) alignment
	)

fn readFixedString bstream fixedLen = (
	local i,str = ""
	for i = 1 to fixedLen do (
		str += bit.intAsChar (ReadByte bstream #unsigned)
		)
	str
	)
fn triangle_strip fstream count = (
	global g
	local face_add=1,matid=1,vertex_start=0
	local count,fa,fb,fc,x,y
	local face_flip = true
	local face_reset=true
	x=0;while x< count do (
		x+=1
		if face_reset == true then (
			x+=2
			face_reset=false
			face_flip = false
			append g.matid matid
			fa = ((readBEshort fstream)-vertex_start) + face_add
			fb = ((readBEshort fstream)-vertex_start) + face_add
			fc = ((readBEshort fstream)-vertex_start) + face_add
			if face_flip == true then (
				append g.face [fa,fc,fb];face_flip=false
				)
			else(
				append g.face [fa,fb,fc];face_flip=true
				)
			)
		else(
			fa = fb;fb = fc;fc = readBEshort fstream
			if fc<0xFFFF then (
				fc-= vertex_start
				fc += face_add
				append g.matid matid
				if face_flip == true then (
					append g.face [fa,fc,fb];face_flip=false
					)
				else(
					append g.face [fa,fb,fc];face_flip=true
					)
				)
			else(
				face_reset=true
				)
			)
		)
	)
fn buildObj = (
	global g
	local j,msh--,mats = copy g.matcount #nomap
-- 	local faceValid = true
-- 	j=1;while j < g.face.count and faceValid == true do (
-- 		if g.face[j][1] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		if g.face[j][2] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		if g.face[j][3] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		j+=1
-- 		)
-- 	if faceValid == false do (g.face = #();print "Face Range Error")
-- 	print g.position.count
-- 	print g.face
	if g.position.count>0 do (
		msh = mesh vertices:g.position faces:g.face-- materialIDs:g.matid --tverts:g.uv_coordinate 
-- 		msh.name = objname
-- 		msh.numTVerts = g.uv_coordinate.count
-- 		msh.displayByLayer = false
-- 		msh.backfacecull = on
		--buildTVFaces msh
		convertTo msh PolyMeshObject
		--for j = 1 to g.uv_coordinate.count do setTVert msh j g.uv_coordinate[j]
		--for j = 1 to g.face.count do setTVFace msh j g.face[j]
-- 		if g.matcount.count > 0 do (
-- 		msh.material = multiMaterial numsubs:g.matcount.count
-- 			sort mats
-- 			for j = 1 to g.matcount.count do (
-- 				msh.material.materialList[j].Diffuse = random (color 0 0 0) (color 255 255 255)
-- 				msh.material.materialList[j].diffuseMap = Bitmaptexture fileName:("tex_"+(paddstring 3 (findItem mats g.matcount[j]))+".tga")
-- 				)
-- 			)
		)
	msh
	)

fn getHeader = (
	global f
	local h = _header(),i=0,p=ftell f
	h.fileid = readFixedString f 3
	h.filever = readbyte f #unsinged
	h.unk1 = readFixedString f 4
	h.unk2 = readBElong f
	h.count = readBElong f
	h.offsets = (
		for i = 1 to h.count collect (
			readBElong f + p
			)
		)
	fseek f (getpadding (ftell f) 16) #seek_cur
	h.sizes = (
		for i = 1 to h.count collect (
			readBElong f
			)
		)
	fseek f (getpadding (ftell f) 16) #seek_cur
	h
	)
fn getSubHeader = (
	global f
	local s = _subheader()
	s.type = readBEshort f
	s.unk1 = readBEshort f
	s.size = readBElong f
	s.unk2 = readBElong f
	s.unk3 = readBElong f
	s
	)
fn getType08 = ( -- geomety data
	global f
	p = ftell f
	g = _geometry()
	format "GEO @ 0x%\n" (bit.intAsHex((ftell f)as integer))
	
	vertex_block_address = 0x50
	
	fseek f vertex_block_address #seek_cur -- face block
	readlong f #unsigned
	face_block_size = readBElong f
	
	vertex_block_address += face_block_size
	fseek f 0x0C #seek_cur
	face_count = readBElong f
	fseek f 0x08 #seek_cur
-- 	for i = 1 to face_count/3 collect (
-- 		append g.face ([(readBEshort f),(readBEshort f),(readBEshort f)]+1)
-- 		)
	triangle_strip f face_count
	fseek f (vertex_block_address+p) #seek_set
	readBElong f
	readBElong f
	readBElong f
	readBElong f
	readBElong f
	vertex_count = readBElong f
	readBElong f
	readBElong f
	for i = 1 to vertex_count do (
		append g.position [(readBEfloat f),(readBEfloat f),(readBEfloat f)]
		)
	buildObj()
	)
fn getType21 = ( -- string data
	global f
	readstring f
	)
fn get_stuff_table pos = (
	global f
	local t = _filetable()
	t.unk1=readBElong f
	t.unk2=readBElong f
	t.unk3=readBElong f
	t.offsets = (
		for i = 1 to t.unk2 collect (
			readBElong f + pos
			)
		)
	t
	)
fn getStuff pos = (
	global f
	local p=ftell f
	fseek f 0x80 #seek_cur -- FIX ME
	
	-- HEADER HERE DESCRIBES COUNTS FOR DATA BELOW
	check = readlong f #unsigned
	if check == 0x00007042 or check == 0x0000F041 then (
		table = get_stuff_table(pos)
		for i = 1 to table.unk2 do (
			fseek f table.offsets[i] #seek_set
			sb=getSubHeader()
			case sb.type of (
				0x04: () -- matrix?
				0x05: () -- bounding box
				0x07: () -- materials
				0x08: ( -- geometry
					getType08()
					)
				0x0C: () -- ? bonemapping
				0x15: ( -- string data
					getType21()
					)
				default: (
					format "SubBlock Not Supported [%] @ 0x%\n" \
						sb.type (bit.intAsHex((table.offsets[i])as integer))
					)
				)
			)
		)
	else (
		format "Error: Failed to seek to table\n"
		)
	)	
clearlistener()
if filen!=undefined and doesFileExist filen == true then (
	try(fclose f)catch(gc())
	f = fopen filen "rb"
	hdr = getHeader()
	for d = 1 to hdr.count do (
		fseek f hdr.offsets[d] #seek_set
		filetype = readlong f #unsigned
		fseek f hdr.offsets[d] #seek_set
		case filetype of (
			0x00000000: (
				getStuff(hdr.offsets[d])
				)
			0x01444D58: (
				hdr = getHeader()
				for d = 1 to hdr.count do (
					fseek f hdr.offsets[d] #seek_set
					filetype = readlong f #unsigned
					fseek f hdr.offsets[d] #seek_set
					case filetype of (
						0x00000000: (
							getStuff(hdr.offsets[d])
							)
						0x00445458: ( -- XTD
							
							)
						default: (
							format "Error: New Block Type [%] @ Address: 0x%\n" \
								filetype (bit.intAsHex((hdr.offsets[d])as integer))
							)
						)
					)
				)
			0x00445458: ( -- XTD
				
				)
			default: (
				format "Error: New Block Type [%] @ Address: 0x%\n" \
					filetype (bit.intAsHex((hdr.offsets[d])as integer))
				)
			)
		)
	
	format "Last Read @ 0x%\n" (bit.intAsHex((ftell f)as integer))
	fclose f
	)
else (
	format "Aborted\n"
	)